/*
    pinco - a didactic framework for Web development
    Copyright (C) 2002-2003  Giansalvatore Mecca - mecca@unibas.it

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ----
    pinco - un framework didattico per lo sviluppo Web
    Copyright (C) 2002-2003  Giansalvatore Mecca - mecca@unibas.it

    Questo  programma   software  libero;   lecito redistribuirlo  o
    modificarlo secondo i termini  della Licenza Pubblica Generica GNU
    come  pubblicata dalla Free  Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.

    Questo programma   distribuito nella  speranza che sia  utile, ma
    SENZA  ALCUNA GARANZIA;  senza  neppure la  garanzia implicita  di
    NEGOZIABILIT  o di  APPLICABILIT PER  UN PARTICOLARE  SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.

    Questo  programma deve  essere  distribuito assieme  ad una  copia
    della Licenza Pubblica Generica GNU;  in caso contrario, se ne pu
    ottenere  una scrivendo  alla Free  Software Foundation,  Inc., 59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA

*/

package it.unibas.pinco.test;

import junit.framework.*;
import it.unibas.pinco.azioni.*;
import it.unibas.pinco.azioni.ActionFactory;
import it.unibas.pinco.framework.PincoException;

public class TestCommandFactory extends TestCase {
    
    public void testGetAzioneIniziale() throws PincoException {
        ActionFactory commandFactory = ActionFactory.getInstance();
        AzioneIniziale azioneIniziale = commandFactory.getAzioneIniziale("it.unibas.pinco.test.azionitest.AzioneInizialeTest");
        assertTrue("non nulla", azioneIniziale != null);
        try {
            AzioneIniziale azioneIniziale2 = commandFactory.getAzioneIniziale("it.unibas.pinco.test.azionitest.AzioneFinaleTest");
            fail();
        } catch (Exception e) {
            //System.out.println("ok: errore di cast");
        }
        try {
            AzioneIniziale azioneIniziale3 = commandFactory.getAzioneIniziale("it.unibas.pinco.test.azionitest.xxx");
            fail();
        } catch (Exception e) {
            //System.out.println("ok: classe non esistente");
        }
    }

    public void testGetAzioneFinale() throws PincoException {
        ActionFactory commandFactory = ActionFactory.getInstance();
        AzioneFinale azioneFinale = commandFactory.getAzioneFinale("it.unibas.pinco.test.azionitest.AzioneFinaleTest");
        assertTrue("non nulla", azioneFinale != null);
        try {
            AzioneFinale azioneFinale2 = commandFactory.getAzioneFinale("it.unibas.pinco.test.azionitest.AzioneInizialeTest");
            fail();
        } catch (Exception e) {
            //System.out.println("ok: errore di cast");
        }
        try {
            AzioneFinale azioneFinale3 = commandFactory.getAzioneFinale("it.unibas.pinco.test.azionitest.xxx");
            fail();
        } catch (Exception e) {
            //System.out.println("ok: classe non esistente");
        }
    }

     public void testGetAzione() throws PincoException {
        ActionFactory commandFactory = ActionFactory.getInstance();
        Azione azione1 = commandFactory.getAzione("it.unibas.pinco.test.azionitest.AzioneTest");
        assertTrue("non nulla", azione1 != null);
        Azione azione2 = commandFactory.getAzione("it.unibas.pinco.test.azionitest.AzioneTest");
        assertTrue("cache", azione1 == azione2);
        try {
            Azione azione3 = commandFactory.getAzione("it.unibas.pinco.test.azionitest.AzioneIniziale");        
            fail();
        } catch (Exception e) {
            //System.out.println("ok: errore di cast");
        }
        try {
            Azione azione4 = commandFactory.getAzione("it.unibas.pinco.test.azionitest.xxx");        
            fail();
        } catch (Exception e) {
            //System.out.println("ok: classe non esistente");
        }
    }

}
