/*
    pinco - a didactic framework for Web development
    Copyright (C) 2002-2003  Giansalvatore Mecca - mecca@unibas.it

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ----
    pinco - un framework didattico per lo sviluppo Web
    Copyright (C) 2002-2003  Giansalvatore Mecca - mecca@unibas.it

    Questo  programma   software  libero;   lecito redistribuirlo  o
    modificarlo secondo i termini  della Licenza Pubblica Generica GNU
    come  pubblicata dalla Free  Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.

    Questo programma   distribuito nella  speranza che sia  utile, ma
    SENZA  ALCUNA GARANZIA;  senza  neppure la  garanzia implicita  di
    NEGOZIABILIT  o di  APPLICABILIT PER  UN PARTICOLARE  SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.

    Questo  programma deve  essere  distribuito assieme  ad una  copia
    della Licenza Pubblica Generica GNU;  in caso contrario, se ne pu
    ottenere  una scrivendo  alla Free  Software Foundation,  Inc., 59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA

*/

package it.unibas.pinco.test;

import junit.framework.*;
import it.unibas.pinco.framework.*;
import it.unibas.pinco.configurazione.Configurazione;
import it.unibas.pinco.utilita.ResourceManager;
import it.unibas.pinco.xml.DAOConfigurazione;

public class TestDAOConfigurazione extends TestCase {
    
    private Configurazione configurazione;
    private String file1 = "/dati/pinco-config-test1.xml";
    private String file2 = "/dati/pinco-config-test2.xml";
    private String file3 = "/dati/pinco-config-test3.xml";
    
    protected void setUp() {
        this.configurazione = new Configurazione();
    }
    
    public void testCarica1() throws PincoException {
        String nomeFile = ResourceManager.getURI(file1).toString();
        configurazione = DAOConfigurazione.getInstance().carica(nomeFile);
        assertTrue("azione iniziale", configurazione.getAzioneIniziale().equals("prova.ProvaAzioneIniziale"));
        assertTrue("azione finale", configurazione.getAzioneFinale().equals("prova.ProvaAzioneFinale"));
        assertTrue("azione 1", configurazione.getAzione("comando1.cmd").equals("prova.Comando1"));
        assertTrue("schermo 1", configurazione.getSchermoSuccessivo("comando1.cmd", "esito1").equals("/schermo1.jsp"));
        assertTrue("schermo 2", configurazione.getSchermoSuccessivo("comando1.cmd", "esito2").equals("/schermo2.jsp"));
        assertTrue("schermo 3", configurazione.getSchermoSuccessivo("comando1.cmd", "esito3").equals("/schermo3.jsp"));
        assertTrue("schermo nullo", configurazione.getSchermoSuccessivo("comando1.cmd", "xxx") == null);
        assertTrue("azione 2", configurazione.getAzione("comando2.cmd").equals("prova.Comando2"));
        assertTrue("schermo 1", configurazione.getSchermoSuccessivo("comando2.cmd", "esito1").equals("/schermo1.jsp"));
        assertTrue("schermo nullo", configurazione.getSchermoSuccessivo("comando2.cmd", "xxx") == null);
    }

    public void testCarica2() throws PincoException {
        String nomeFile = ResourceManager.getURI(file2).toString();
        configurazione = DAOConfigurazione.getInstance().carica(nomeFile);
        assertTrue("azione iniziale", configurazione.getAzioneIniziale() == null);
        assertTrue("azione finale", configurazione.getAzioneFinale() == null);
        assertTrue("azione 1", configurazione.getAzione("comando1.cmd").equals("prova.Comando1"));
        assertTrue("schermo 1", configurazione.getSchermoSuccessivo("comando1.cmd", "esito1").equals("/schermo1.jsp"));
        assertTrue("schermo 2", configurazione.getSchermoSuccessivo("comando1.cmd", "esito2").equals("/schermo2.jsp"));
        assertTrue("schermo 3", configurazione.getSchermoSuccessivo("comando1.cmd", "esito3").equals("/schermo3.jsp"));
        assertTrue("schermo nullo", configurazione.getSchermoSuccessivo("comando1.cmd", "xxx") == null);
        assertTrue("azione 2", configurazione.getAzione("comando2.cmd").equals("prova.Comando2"));
        assertTrue("schermo 1", configurazione.getSchermoSuccessivo("comando2.cmd", "esito1").equals("/schermo1.jsp"));
        assertTrue("schermo nullo", configurazione.getSchermoSuccessivo("comando2.cmd", "xxx") == null);
    }

    public void testCarica3() throws PincoException {
        String nomeFile = ResourceManager.getURI(file3).toString();
        configurazione = DAOConfigurazione.getInstance().carica(nomeFile);
        assertTrue("azione iniziale", configurazione.getAzioneIniziale() == null);
        assertTrue("azione finale", configurazione.getAzioneFinale() == null);
        assertTrue("azione 1", configurazione.getAzione("comando1.cmd") == null);
        assertTrue("azione 2", configurazione.getAzione("comando2.cmd") == null);
    }
}
